%% Paramterek betltse
% A kvetkez parancssorban a <neptun> helyre rja be sajt Neptun-kdjt,
% pl. load abc123 meres_u meres_y;
% A parancs a <neptun>.mat fjlbl a kvetkez vltozkba tlti a megfelel
% paramtereket:
% m   - a mozgatott teher tmege
% M   - a kocsi tmege
% J   - a sodronyt tekercsel motor s a dob tehetetlensgi nyomatka
% rho - a dob sugara 
% L0  - a sodrony hossza a munkapontban
% y0  - a kocsi pozcija a munkapontban
close all
clear all
load slz0ue m M J rho L0 y0;
g=9.81;
%% Tervezsi elrsok
% A feladatkirs szerinti tervezsi elrsok az albbiak, a kirsnak
% megfelelen nagy beavatkoz jelek esetn ezeket mdosthatja.
% Figyelem! A mdostsokat itt hajtsa vgre, a vltozneveket ne cserlje
% le!
% gyeljen a dnorm normalizl tnyez s a Tdstart paramter helyes
% megvlasztsra!
a=sqrt((m+M)*g/(m*L0));
w0=a/2;
xi=0.7;
scinf=-a;
soinf=-2*a;
Ta=1/w0;
%Tdstart=2/a;
Tdstart=4;
%dnorm=1;
dnorm=0.01;

%% A szakasz modelljnek meghatrozsa
% A szakasz Wrf s Wltau tviteli fggvnyeit az albbi vltozkban trolja
% Wrf   - a szakasz Wrf tviteli fggvnye
% Wltau - a szakasz Wltau tviteli fggvny
syms m M J rho g L0 s

Asym=[0 0 1 0 0 0;
	  0 0 0  1 0 0;
      0 m*g/M 0 0 0 0;
      0 -g*(m+M)/L0/M 0 0 0 0;
      0 0 0 0 0 1;
      0 0 0 0 0 0];

Bsym=[0 0 ;
      0 0;
      1/M 0;
      -1/L0/M 0;
      0 0;
      0 -1/(m*rho+J/rho)];

Csym=[1 0 0 0 0 0;
      0 0 0 0 1 0];

Dsym=[0 0;
      0 0];

I=eye(6);
Wsym=Csym*inv((s*I-Asym))*Bsym+Dsym;
Wrfsym=Wsym(1,1)
Wltausym=Wsym(2,2)
clear m M J rho g L0 s


%% Szabalyozotervezes
load slz0ue m M J rho L0 y0;
g=9.81;

A=[0 0 1 0 0 0;
   0 0 0  1 0 0;
   0 m*g/M 0 0 0 0;
   0 -g*(m+M)/L0/M 0 0 0 0;
   0 0 0 0 0 1;
   0 0 0 0 0 0];

B=[0 0 ;
   0 0;
   1/M 0;
   -1/L0/M 0;
   0 0;
   0 -1/(m*rho+J/rho)];

C=[1 0 0 0 0 0;
   0 0 0 0 1 0];

D=[0 0;
   0 0];

A1=A(1:4,1:4);
A2=A(5:6,5:6);
C1=C(1,1:4);
C2=C(2,5:6);
D1=D(1,1);
D2=D(2,2);
B1=B(1:4,1);
B2=B(5:6,2);

[sys1.num, sys1.den]=ss2tf(A1, B1, C1, D1);
[sys2.num, sys2.den]=ss2tf(A2, B2, C2, D2);
Wrf=tf(sys1.num,sys1.den)
Wltau=tf(sys2.num, sys2.den)

pol1=roots(sys1.den)
pol2=roots(sys2.den)
zer1=roots(sys1.num)
zer2=roots(sys2.num)

%Allapot visszacsatolas
Mc=ctrb(A,B);
rank(Mc)

sdom1=-w0*xi+1j*w0*sqrt(1-xi^2);
sdom2=conj(sdom1);
phic1=[sdom1 sdom2 scinf scinf];    % A zart kor gyokei
phic2=[sdom1 sdom2];

K1=acker(A1,B1,phic1)
K2=acker(A2,B2,phic2)

%Alapjel korrekcio
NxNu1=inv([A1 B1; C1 0])*[zeros(4,1);1];    % n=4, m=1
Nx1=NxNu1(1:4)
Nu1=NxNu1(5)
NxNu2=inv([A2 B2; C2 0])*[zeros(2,1);1];    % n=2, m=1
Nx2=NxNu2(1:2)
Nu2=NxNu1(3)

%Terheles becsles
Atilde1=[A1 B1; zeros(1,5)];
Btilde1=[B1; 0];
Ctilde1=[C1 0];
phiotilde1=[ones(1,4)*soinf soinf];     		% Zajjal terhelt rendszer kar.polija
Gtilde1=acker(Atilde1',Ctilde1',phiotilde1)';   % Allapot megfigyelo a zajos rendszerhez
Ftilde1=Atilde1-Gtilde1*Ctilde1;
Htilde1=Btilde1;

Atilde2=[A2 B2; zeros(1,3)];
Btilde2=[B2; 0];
Ctilde2=[C2 0];
phiotilde2=[ones(1,2)*soinf soinf];     		% Zajjal terhelt rendszer kar.polija
Gtilde2=acker(Atilde2',Ctilde2',phiotilde2)';   % Allapot megfigyelo a zajos rendszerhez
Ftilde2=Atilde2-Gtilde2*Ctilde2;
Htilde2=Btilde2;

Ftilde=blkdiag(Ftilde1, Ftilde2);
Gtilde=blkdiag(Gtilde1, Gtilde2);
Htilde=blkdiag(Htilde1, Htilde2);
Nu=blkdiag(Nu1, Nu2);
Nx=blkdiag(Nx1, Nx2);
K=blkdiag(K1, K2);

%% Szimulci
% A szimulcit a mellkelt sim.mdl modell alapjn elksztett
% <neptun>sim.mdl nven (pl. abc123sim.mdl) mentett Simulink-modellel 
% vgezze! A modellben tallhat alapjel- s terhels-generl blokkok a 
% fenti paramtereket (y0,Tdstart,Ta,m,M,g,rho) hasznljk, gy a szimulci 
% eltt mindig futtassa le ezt a scriptet!
